var hourDisplay;
var minuteDisplay;
var secondDisplay;
var tenthsecondDisplay;

function calculateDiffTimer() {
	now = new Date();	
	diffMs = now.getTime() - start.getTime();
	var diff = diffMs;
	hourDisplay = Math.floor(diff / HOUR);
	diff = diff - (hourDisplay * HOUR);
	minuteDisplay = Math.floor(diff / MINUTE);
	diff = diff - (minuteDisplay * MINUTE);
	secondDisplay = Math.floor(diff / SECOND);
	diff = diff - (secondDisplay * SECOND);
	tenthsecondDisplay = Math.floor(diff / TENTHSECOND);	 
	
	if((hourDisplay == MAX_HOUR && minuteDisplay >= MAX_MINUTE && secondDisplay >= MAX_SECOND) || hourDisplay > MAX_HOUR) {
		setLabelsLiveconView('' + hourDisplay, '' + minuteDisplay, '' + secondDisplay, '' + tenthsecondDisplay);
		setLabelsCountTimer('' + hourDisplay, '' + minuteDisplay, '' + secondDisplay, '' + tenthsecondDisplay);
		updatePersistenceData('' + hourDisplay, '' + minuteDisplay, '' + secondDisplay, '' + tenthsecondDisplay);

		clearInterval(timer);	
		widget.setPreferenceForKey(STATUS_LIMIT, "status");
		loadMenu(LIMIT_TIMER_MENU);
		document.getElementById('imgButton').src = 'resource/images/button_play_active_disable.png';
		
		return '0';
	}
	
	return '1';
}
/**
 * Action from softkey item that opens the feed's source site
 */
function startTimer() {
	now = new Date();
	start = new Date();
	lastLapClock = new Date();
	lapCount = 0;
	lapClock = new Date();
	lapClock.setTime(0);
	
	timer = setInterval( 'refresh()', REFRESH_INTERVAL);
	
   	loadMenu(COUNT_TIMER_MENU);
   	validateLapsNumber();
   	widget.setPreferenceForKey(STATUS_COUNTING, "status");
   	widget.setPreferenceForKey("", "laps");
}

function refresh() {
	calculateDiffTimer();
	
	var lapInterval = now.getTime() - lapClock.getTime();
	if(lapInterval > LAP_INTERVAL) {
		setLabelsCountTimer('' + hourDisplay, '' + minuteDisplay, '' + secondDisplay, '' + tenthsecondDisplay);
		setLabelsLiveconView('' + hourDisplay, '' + minuteDisplay, '' + secondDisplay, '' + tenthsecondDisplay);
		updatePersistenceData('' + hourDisplay, '' + minuteDisplay, '' + secondDisplay, '' + tenthsecondDisplay);		
	}
}
 
function stopTimer() {
	calculateDiffTimer();
	
	setLabelsCountTimerOnPauseStop('' + hourDisplay, '' + minuteDisplay, '' + secondDisplay, '' + tenthsecondDisplay);
	setLabelsLiveconViewOnPauseStop('' + hourDisplay, '' + minuteDisplay, '' + secondDisplay, '' + tenthsecondDisplay);
	updatePersistenceData('' + hourDisplay, '' + minuteDisplay, '' + secondDisplay, '' + tenthsecondDisplay);
	
	document.getElementById('imgButton').src = 'resource/images/button_play.png';
	
	clearInterval(timer);	
	widget.setPreferenceForKey(STATUS_STOP, "status");
	loadMenu(STOP_TIMER_MENU);	
}

function restartTimer() {
	var newStart = new Date();
	lapClock = new Date();
	lapClock.setTime(0);
	if(validateLapsNumber() == '0') {
		document.getElementById('imgButton').src = 'resource/images/button_lap_disable.png';
	} else {
		document.getElementById('imgButton').src = 'resource/images/button_lap.png';
	}
	
	var hour = widget.preferenceForKey("hour");
	var minute = widget.preferenceForKey("minute");
	var second = widget.preferenceForKey("second");
	var tenthsecond = widget.preferenceForKey("tenthsecond");

	var diff = (hour * HOUR) + (minute * MINUTE) + (second * SECOND) + (tenthsecond * TENTHSECOND);
	
	//stop time: actual - initial start - passed time
	var stopTime = newStart.getTime() - start.getTime() - diff;
	
	//restart time: initial start + stop time
	var newStartTime = start.getTime() + stopTime;
	
	//new start time
	start.setTime(newStartTime);
	//new last lap clock
	lastLapClock.setTime(lastLapClock.getTime() + stopTime);
	
	timer = setInterval( 'refresh()', REFRESH_INTERVAL );

	loadMenu(COUNT_TIMER_MENU);
	widget.setPreferenceForKey(STATUS_COUNTING, "status");
}

function resetTimer() {	
	setLabelsCountTimer('0', '0', '0', '0');
	setLabelsLiveconView('0', '0', '0', '0');
	updatePersistenceData('0', '0', '0', '0');
	var divLaps = document.getElementById("laps");
	var tableLaps = document.getElementById("tableLaps");
	if(tableLaps != undefined) {
		divLaps.removeChild(tableLaps);
	}
	document.getElementById('hiddenObj').onblur = "javascript: void(0)";
	scrollBar.restart();
	scrollBar.refresh(); 
	loadMenu(START_TIMER_MENU);
   	widget.setPreferenceForKey(STATUS_INITIAL, "status");
   	widget.setPreferenceForKey("", "laps");
   	document.getElementById('imgButton').src = 'resource/images/button_play.png';
	document.getElementById('linemiddle1').style.display = 'block';
	document.getElementById('linemiddle2').style.display = 'block';
		
}

function lap() {	
	if(lapCount < MAX_LAPS) {
		lapClock = new Date();
		refresh();
		
		lapCount++;
		
		var lapTime = lapClock.getTime() - lastLapClock.getTime();	
		var hourLap = Math.floor(lapTime / HOUR);
		lapTime = lapTime - (hourLap * HOUR);
		var minuteLap = Math.floor(lapTime / MINUTE);
		lapTime = lapTime - (minuteLap * MINUTE);
		var secondLap = Math.floor(lapTime / SECOND);
		lapTime = lapTime - (secondLap * SECOND);
		var tenthsecondLap = lapTime.toString();
	
		setLabelsCountTimerOnPauseStop('' + hourDisplay, '' + minuteDisplay, '' + secondDisplay, '' + tenthsecondDisplay);
		setLabelsLiveconViewOnPauseStop('' + hourDisplay, '' + minuteDisplay, '' + secondDisplay, '' + tenthsecondDisplay);
	
		//LAP
		var lapString = paddingLeft('' + hourLap, 2, '0') + ':' + paddingLeft('' + minuteLap, 2, '0') + ':' + 
						paddingLeft('' + secondLap, 2, '0') + '.' + tenthsecondLap.substring(0,1);
		 
		var td = createTableLine(lapString);
		
		var allLaps = widget.preferenceForKey("laps");
		
		if(allLaps == undefined || allLaps == "") {	
			allLaps = lapString;
		} else {
			allLaps = allLaps + SEPARATOR + lapString;
		}
		
		widget.setPreferenceForKey(allLaps, "laps");
		
		lastLapClock.setTime(lapClock.getTime());
		
		validateLapsNumber();
		scrollBar.refresh();
	}
}

function eventButton(event) {
	var status = widget.preferenceForKey("status");
	switch(status) {
		case undefined:
		case STATUS_INITIAL:
			if(event == 'down') {
				document.getElementById('imgButton').src = 'resource/images/button_play_active.png';
			} else { //event == up
				//document.getElementById('imgButton').src = 'resource/images/button_play.png';
				startTimer();
				document.getElementById('imgButton').src = 'resource/images/button_lap.png';
			} 
			break;
		case STATUS_COUNTING:
			if(validateLapsNumber() == '0') {
				document.getElementById('imgButton').src = 'resource/images/button_lap_disable.png';
			} else {
				if(event == 'down') {
					document.getElementById('imgButton').src = 'resource/images/button_lap_active.png';
				} else { //event == up
					lap();
					if(validateLapsNumber() == '0') {
						document.getElementById('imgButton').src = 'resource/images/button_lap_disable.png';
					} else {
						document.getElementById('imgButton').src = 'resource/images/button_lap.png';
					}		
				} 
			}
			break;
		case STATUS_STOP:
			if(event == 'down') {
				document.getElementById('imgButton').src = 'resource/images/button_play_active.png';
			} else { //event == up
				//document.getElementById('imgButton').src = 'resource/images/button_play.png';
				restartTimer();
				if(validateLapsNumber() == '0') {
					document.getElementById('imgButton').src = 'resource/images/button_lap_disable.png';
				} else {
					document.getElementById('imgButton').src = 'resource/images/button_lap.png';
				}
			} 
			break;
	}
}