var start;
var now;
var diffMs;
var timer;
var lapCount;
var lapClock;
var lastLapClock;
var scrollBar;

function eventHandler(e){
	var event = window.event;
	var target = event.target;
	var id = target.id;
	
	if(id == "item-detail_scrollBar"){
   		var scrollPosition = document.getElementById("item-detail_scroll").offsetTop;
   		scrollPosition = scrollPosition + 105;
   		var mousePosition = e.pageY;
   		
   		if(scrollPosition > mousePosition){
   			scrollBar.scroll("up", 3);		
   		}
   		else{
   			scrollBar.scroll("down", 3);		
   		}  	
   	}
}

function updateScrollPosition(e){
   	var scrollPosition = document.getElementById("item-detail_scroll").offsetTop;
   	scrollPosition = scrollPosition;
   	var mousePosition = e.pageY - 105; 
   	
   	if(scrollPosition > mousePosition){
   		scrollBar.scroll("up", undefined);	
   	}
   	else{
   		scrollBar.scroll("down", undefined);
   	}
}

function updateMouse(e){
    var item = e.target;
    if (item && item.id) {
       var id = item.id;
       if(id.match("scroll")){
       		if(id.match("scrollBar")){
           		 updateScrollPosition(e);
            } 
            else{

       		}
       	    
       }
       else{

       }
    }
}

function mouseDown(e){
	var item = e.target;
    if (item && item.id) {
       var id = item.id;
       if( id == "item-detail_scroll" ){
       		scrollbarClicked = true;   
       		window.addEventListener('mousemove',updateMouse,false);    
       }
       else{
       		scrollbarClicked = false; 
       		window.removeEventListener('mousemove',updateMouse,false);
       }      
    }
    else{
    	window.removeEventListener('mousemove',updateMouse,false);
    	scrollbarClicked = false;
   } 
}

function mouseUp(e){
	if(scrollbarClicked){
		var item = e.target;
	    if (item && item.id) {
	       var id = item.id;
	       if(id.match("scrollBar")){  
	       		scrollbarClicked = false;   		
	       		window.removeEventListener('mousemove',updateMouse,false);  
	       		updateScrollPosition(e);	       			       		     
	       }
	       else{
	       		scrollbarClicked = false; 
	       		window.removeEventListener('mousemove',updateMouse,false);
	       }
	    }
	    else{
	       	scrollbarClicked = false; 
	       	window.removeEventListener('mousemove',updateMouse,false);
	    }
    }
    else{
    }
}

/**
 * Handle the WebUI container events.
 */
function onLoadAction(){
	initLabels();
	initScrollBar();
	
	document.onmousedown = mouseDown;
	document.onmouseup = mouseUp;
	
	//  onLaunch occurs when:
	//	1) The user initially launches the widget, or
	// 	2) The user reactivates the widget after deactivating it
	webui.onLaunch = onLaunchAction;
	
	//  onViewSwitch occurs when the user moves from livecon 
	//  to detailed view, or the reverse	
	webui.onViewSwitch = onViewSwitchAction;
	
	document.getElementById('hiddenObj').focus();	
}

function initLabels() {
	setLabelsCountTimer('0', '0', '0', '0');
	setLabelsLiveconView('0', '0', '0', '0');
	
	var status = widget.preferenceForKey("status");
	if(status != undefined && status != STATUS_INITIAL) {
		var hour = widget.preferenceForKey("hour");
		var minute = widget.preferenceForKey("minute");
		var second = widget.preferenceForKey("second");
		var tenthsecond = widget.preferenceForKey("tenthsecond");
		setLabelsCountTimer(hour, minute, second, tenthsecond);
		setLabelsLiveconView(hour, minute, second, tenthsecond);
		
		if (status == STATUS_STOP) {
			setTenthSecondsLabelCountTimer(tenthsecond);
			setTenthSecondsLabelLiveconView(tenthsecond);
		}
		
		var startAux = widget.preferenceForKey("start");
		start = new Date();
		start.setTime(startAux * 1);
		
		var lastLapClockAux = widget.preferenceForKey("lastLapClock");
		lastLapClock = new Date();
		lastLapClock.setTime(lastLapClockAux * 1);
		
		lapClock = new Date();
		lapClock.setTime(0);
	
		if(timer == undefined && status == STATUS_COUNTING) {
			if(calculateDiffTimer() == '1') {
				timer = setInterval( 'refresh()', REFRESH_INTERVAL);
			} else {
				setLabelsCountTimer(MAX_HOUR, MAX_MINUTE, MAX_SECOND, '0');
				setLabelsLiveconView(MAX_HOUR, MAX_MINUTE, MAX_SECOND, '0');
				updatePersistenceData(MAX_HOUR, MAX_MINUTE, MAX_SECOND, '0');
				widget.setPreferenceForKey(STATUS_LIMIT, "status");
			}
		}
	}
}

function initScrollBar() {
	scrollBar = new ScrollBar('page', 'item-detail_scrollBar' , 'item-detail_scroll', 'lapscontent', 'laps');
}

/**
* Check which view is requested when the widget is launched and display it.
*/
function onLaunchAction(){

	switch(webui.viewType){
		// Detailed view
		case webui.defs.viewType.DETAILED_VIEW:
			updateDetailedView();
			break;
		
		// Livecon view
		case webui.defs.viewType.LIVECON_VIEW:
			updateLiveconView();
			break;
	}
}	


/**
* Switch between the livecon and detailed view.
*/
function onViewSwitchAction(){
    switch(webui.viewType){
    	// Detailed view
    	case webui.defs.viewType.DETAILED_VIEW:
    		window.addEventListener('click',eventHandler,false);
    		updateDetailedView();
            break;
         
        // Livecon view      
        case webui.defs.viewType.LIVECON_VIEW:
        	updateLiveconView();
        	break;
	}
}

function updateDetailedView() {
	var status = widget.preferenceForKey("status");
	showView(COUNTTIMER_VIEW);
	switch(status) {
		case undefined:
		case STATUS_INITIAL:
			break;
		case STATUS_COUNTING:
		case STATUS_STOP:
		case STATUS_LIMIT:
			if(lapCount == undefined) {
				lapCount = 0;	
												
				var allLaps = widget.preferenceForKey("laps");
				
				if(allLaps != undefined && allLaps != "") {
					var arrayOfLaps = allLaps.split(SEPARATOR);
					
					for(var i = 0; i < arrayOfLaps.length; i++) {	
						lapCount++;
						createTableLine(arrayOfLaps[i]);
					}
				}
			}
			scrollBar.refresh();
			
			if(status == STATUS_STOP || status == STATUS_LIMIT) {
				loadMenu(STOP_TIMER_MENU);
				
				if(status == STATUS_LIMIT) {
					document.getElementById('imgButton').src = 'resource/images/button_play_active_disable.png';
				}
			} else {
				loadMenu(COUNT_TIMER_MENU);
				if(validateLapsNumber() == '0') {
					document.getElementById('imgButton').src = 'resource/images/button_lap_disable.png';
				} else {
					document.getElementById('imgButton').src = 'resource/images/button_lap.png';
				}
			}
			break;
	}
}

function updateLiveconView() {
	var status = widget.preferenceForKey("status");
	switch(status) {
		case undefined:
		case STATUS_INITIAL:
			showView(LIVECON_INITIAL_VIEW);
			break;
		case STATUS_LIMIT:
		case STATUS_COUNTING:
		case STATUS_STOP:
			showView(LIVECON_VIEW);	
			break;
	}
}