var KEY_CODE_UP = 38; // Key code for up soft key
var KEY_CODE_DOWN = 40; // Key code for down soft key
var KEY_CODE_CENTER = 13;

var REFRESH_INTERVAL = 200;

var SEPARATOR = "|";
var MAX_LAPS = 50;

var HOUR = 1000 * 60 * 60;
var MINUTE = 1000 * 60;
var SECOND = 1000;
var TENTHSECOND = 100;

var MAX_HOUR = 99;
var MAX_MINUTE = 59;
var MAX_SECOND = 59;

var LAP_INTERVAL = 2 * SECOND;

var LIVECON_VIEW = 'livecon-view';
var LIVECON_INITIAL_VIEW = 'livecon-view-initial';
var COUNTTIMER_VIEW = 'detailed-view';

var START_TIMER_MENU = 'default';
var COUNT_TIMER_MENU = 'countTimer';
var STOP_TIMER_MENU = 'stopTimer';
var LIMIT_TIMER_MENU = 'stopTimer'; //max: 99:59:59

var STARTTIMER_ACTION = 'startTimer';
var LAP_ACTION = 'lap';
var STOPTIMER_ACTION = 'stopTimer';
var RESTARTTIMER_ACTION = 'restartTimer';
var RESETTIMER_ACTION = 'resetTimer';

var STATUS_INITIAL = "0";
var STATUS_COUNTING = "1";
var	STATUS_STOP = "2";
var	STATUS_LIMIT = "3";

function paddingLeft(str, len, character) {
	while (str.length < len) {
		str = character + str;
	}
	return str;
}

/**
 * Loads the menu according to a given context
 *
 * @param context String that defines context of the menu to be loaded. 
 *				 Its defined on SKMenu.xml file.
 */
function loadMenu(context) {
	skMenu = webui.softKeys.loadMenu(context);
	skMenu.addListener(listener);
    webui.softKeys.setActiveMenu(skMenu);
}


function updatePersistenceData(hour, minute, second, tenthsecond) {
	widget.setPreferenceForKey(hour, "hour");
	widget.setPreferenceForKey(minute, "minute");
	widget.setPreferenceForKey(second, "second");
	widget.setPreferenceForKey(tenthsecond, "tenthsecond");
	widget.setPreferenceForKey(start.getTime(), "start");
	widget.setPreferenceForKey(lastLapClock.getTime(), "lastLapClock");
	widget.setPreferenceForKey(lapCount, "lapCount");
}

/**
* Get the CSS definitions of a class
* 
* @param  styleSheetId 		style sheet id (include index)
* @param  className 		css class	
* @return Rules				css rules   
*/
function getStyleClass (styleSheetId, className) {
	
	
	for (var i = 0; i < document.styleSheets[styleSheetId].rules.length; i++){
		var selectorText = document.styleSheets[styleSheetId].rules[i].selectorText;
		selectorText = selectorText.replace(/\[.*\]/g , "");
		if ((selectorText.lastIndexOf("." + className) >= 0)  && (selectorText.lastIndexOf("." + className) == Number(selectorText.length - className.length -1))){
			return document.styleSheets[styleSheetId].rules[i];
		}
	}
	
	return undefined;
	
}

/**
* Get window size (height/width)
* 
* @return  WindowSize	object that contains height and width attributes
*/
function getWindowSize(){
	
	return new WindowSize(window.innerHeight, window.innerWidth);
	
	function WindowSize(height, width){
		
		this.height = height;
		this.width = width;
		
	}
}